install.sh 11 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285
  1. #!/bin/bash
  2. red='\033[0;31m'
  3. green='\033[0;32m'
  4. yellow='\033[0;33m'
  5. plain='\033[0m'
  6. cur_dir=$(pwd)
  7. # check root
  8. [[ $EUID -ne 0 ]] && echo -e "${red}Fatal error: ${plain} Please run this script with root privilege \n " && exit 1
  9. # Check OS and set release variable
  10. if [[ -f /etc/os-release ]]; then
  11. source /etc/os-release
  12. release=$ID
  13. elif [[ -f /usr/lib/os-release ]]; then
  14. source /usr/lib/os-release
  15. release=$ID
  16. else
  17. echo "Failed to check the system OS, please contact the author!" >&2
  18. exit 1
  19. fi
  20. echo "The OS release is: $release"
  21. arch() {
  22. case "$(uname -m)" in
  23. x86_64 | x64 | amd64) echo 'amd64' ;;
  24. i*86 | x86) echo '386' ;;
  25. armv8* | armv8 | arm64 | aarch64) echo 'arm64' ;;
  26. armv7* | armv7 | arm) echo 'armv7' ;;
  27. armv6* | armv6) echo 'armv6' ;;
  28. armv5* | armv5) echo 'armv5' ;;
  29. s390x) echo 's390x' ;;
  30. *) echo -e "${green}Unsupported CPU architecture! ${plain}" && rm -f install.sh && exit 1 ;;
  31. esac
  32. }
  33. echo "arch: $(arch)"
  34. os_version=""
  35. os_version=$(grep "^VERSION_ID" /etc/os-release | cut -d '=' -f2 | tr -d '"' | tr -d '.')
  36. if [[ "${release}" == "arch" ]]; then
  37. echo "Your OS is Arch Linux"
  38. elif [[ "${release}" == "parch" ]]; then
  39. echo "Your OS is Parch Linux"
  40. elif [[ "${release}" == "manjaro" ]]; then
  41. echo "Your OS is Manjaro"
  42. elif [[ "${release}" == "armbian" ]]; then
  43. echo "Your OS is Armbian"
  44. elif [[ "${release}" == "alpine" ]]; then
  45. echo "Your OS is Alpine Linux"
  46. elif [[ "${release}" == "opensuse-tumbleweed" ]]; then
  47. echo "Your OS is OpenSUSE Tumbleweed"
  48. elif [[ "${release}" == "openEuler" ]]; then
  49. if [[ ${os_version} -lt 2203 ]]; then
  50. echo -e "${red} Please use OpenEuler 22.03 or higher ${plain}\n" && exit 1
  51. fi
  52. elif [[ "${release}" == "centos" ]]; then
  53. if [[ ${os_version} -lt 8 ]]; then
  54. echo -e "${red} Please use CentOS 8 or higher ${plain}\n" && exit 1
  55. fi
  56. elif [[ "${release}" == "ubuntu" ]]; then
  57. if [[ ${os_version} -lt 2004 ]]; then
  58. echo -e "${red} Please use Ubuntu 20 or higher version!${plain}\n" && exit 1
  59. fi
  60. elif [[ "${release}" == "fedora" ]]; then
  61. if [[ ${os_version} -lt 36 ]]; then
  62. echo -e "${red} Please use Fedora 36 or higher version!${plain}\n" && exit 1
  63. fi
  64. elif [[ "${release}" == "amzn" ]]; then
  65. if [[ ${os_version} != "2023" ]]; then
  66. echo -e "${red} Please use Amazon Linux 2023!${plain}\n" && exit 1
  67. fi
  68. elif [[ "${release}" == "debian" ]]; then
  69. if [[ ${os_version} -lt 11 ]]; then
  70. echo -e "${red} Please use Debian 11 or higher ${plain}\n" && exit 1
  71. fi
  72. elif [[ "${release}" == "almalinux" ]]; then
  73. if [[ ${os_version} -lt 80 ]]; then
  74. echo -e "${red} Please use AlmaLinux 8.0 or higher ${plain}\n" && exit 1
  75. fi
  76. elif [[ "${release}" == "rocky" ]]; then
  77. if [[ ${os_version} -lt 8 ]]; then
  78. echo -e "${red} Please use Rocky Linux 8 or higher ${plain}\n" && exit 1
  79. fi
  80. elif [[ "${release}" == "ol" ]]; then
  81. if [[ ${os_version} -lt 8 ]]; then
  82. echo -e "${red} Please use Oracle Linux 8 or higher ${plain}\n" && exit 1
  83. fi
  84. else
  85. echo -e "${red}Your operating system is not supported by this script.${plain}\n"
  86. echo "Please ensure you are using one of the following supported operating systems:"
  87. echo "- Ubuntu 20.04+"
  88. echo "- Debian 11+"
  89. echo "- CentOS 8+"
  90. echo "- OpenEuler 22.03+"
  91. echo "- Fedora 36+"
  92. echo "- Arch Linux"
  93. echo "- Parch Linux"
  94. echo "- Manjaro"
  95. echo "- Armbian"
  96. echo "- AlmaLinux 8.0+"
  97. echo "- Rocky Linux 8+"
  98. echo "- Oracle Linux 8+"
  99. echo "- OpenSUSE Tumbleweed"
  100. echo "- Amazon Linux 2023"
  101. exit 1
  102. fi
  103. install_base() {
  104. case "${release}" in
  105. ubuntu | debian | armbian)
  106. apt-get update && apt-get install -y -q wget curl tar tzdata
  107. ;;
  108. centos | almalinux | rocky | ol)
  109. yum -y update && yum install -y -q wget curl tar tzdata
  110. ;;
  111. fedora | amzn)
  112. dnf -y update && dnf install -y -q wget curl tar tzdata
  113. ;;
  114. arch | manjaro | parch)
  115. pacman -Syu && pacman -Syu --noconfirm wget curl tar tzdata
  116. ;;
  117. opensuse-tumbleweed)
  118. zypper refresh && zypper -q install -y wget curl tar timezone
  119. ;;
  120. *)
  121. apt-get update && apt install -y -q wget curl tar tzdata
  122. ;;
  123. esac
  124. }
  125. gen_random_string() {
  126. local length="$1"
  127. local random_string=$(LC_ALL=C tr -dc 'a-zA-Z0-9' </dev/urandom | fold -w "$length" | head -n 1)
  128. echo "$random_string"
  129. }
  130. config_after_install() {
  131. local existing_username=$(/usr/local/x-ui/x-ui setting -show true | grep -Eo 'username: .+' | awk '{print $2}')
  132. local existing_password=$(/usr/local/x-ui/x-ui setting -show true | grep -Eo 'password: .+' | awk '{print $2}')
  133. local existing_webBasePath=$(/usr/local/x-ui/x-ui setting -show true | grep -Eo 'webBasePath: .+' | awk '{print $2}')
  134. local existing_port=$(/usr/local/x-ui/x-ui setting -show true | grep -Eo 'port: .+' | awk '{print $2}')
  135. local server_ip=$(curl -s https://api.ipify.org)
  136. if [[ ${#existing_webBasePath} -lt 4 ]]; then
  137. if [[ "$existing_username" == "admin" && "$existing_password" == "admin" ]]; then
  138. local config_webBasePath=$(gen_random_string 15)
  139. local config_username=$(gen_random_string 10)
  140. local config_password=$(gen_random_string 10)
  141. read -p "Would you like to customize the Panel Port settings? (If not, a random port will be applied) [y/n]: " config_confirm
  142. if [[ "${config_confirm}" == "y" || "${config_confirm}" == "Y" ]]; then
  143. read -p "Please set up the panel port: " config_port
  144. echo -e "${yellow}Your Panel Port is: ${config_port}${plain}"
  145. else
  146. local config_port=$(shuf -i 1024-62000 -n 1)
  147. echo -e "${yellow}Generated random port: ${config_port}${plain}"
  148. fi
  149. /usr/local/x-ui/x-ui setting -username "${config_username}" -password "${config_password}" -port "${config_port}" -webBasePath "${config_webBasePath}"
  150. echo -e "This is a fresh installation, generating random login info for security concerns:"
  151. echo -e "###############################################"
  152. echo -e "${green}Username: ${config_username}${plain}"
  153. echo -e "${green}Password: ${config_password}${plain}"
  154. echo -e "${green}Port: ${config_port}${plain}"
  155. echo -e "${green}WebBasePath: ${config_webBasePath}${plain}"
  156. echo -e "${green}Access URL: http://${server_ip}:${config_port}/${config_webBasePath}${plain}"
  157. echo -e "###############################################"
  158. echo -e "${yellow}If you forgot your login info, you can type 'x-ui settings' to check${plain}"
  159. else
  160. local config_webBasePath=$(gen_random_string 15)
  161. echo -e "${yellow}WebBasePath is missing or too short. Generating a new one...${plain}"
  162. /usr/local/x-ui/x-ui setting -webBasePath "${config_webBasePath}"
  163. echo -e "${green}New WebBasePath: ${config_webBasePath}${plain}"
  164. echo -e "${green}Access URL: http://${server_ip}:${existing_port}/${config_webBasePath}${plain}"
  165. fi
  166. else
  167. if [[ "$existing_username" == "admin" && "$existing_password" == "admin" ]]; then
  168. local config_username=$(gen_random_string 10)
  169. local config_password=$(gen_random_string 10)
  170. echo -e "${yellow}Default credentials detected. Security update required...${plain}"
  171. /usr/local/x-ui/x-ui setting -username "${config_username}" -password "${config_password}"
  172. echo -e "Generated new random login credentials:"
  173. echo -e "###############################################"
  174. echo -e "${green}Username: ${config_username}${plain}"
  175. echo -e "${green}Password: ${config_password}${plain}"
  176. echo -e "###############################################"
  177. echo -e "${yellow}If you forgot your login info, you can type 'x-ui settings' to check${plain}"
  178. else
  179. echo -e "${green}Username, Password, and WebBasePath are properly set. Exiting...${plain}"
  180. fi
  181. fi
  182. /usr/local/x-ui/x-ui migrate
  183. }
  184. install_x-ui() {
  185. cd /usr/local/
  186. if [ $# == 0 ]; then
  187. tag_version=$(curl -Ls "https://api.github.com/repos/MHSanaei/3x-ui/releases/latest" | grep '"tag_name":' | sed -E 's/.*"([^"]+)".*/\1/')
  188. if [[ ! -n "$tag_version" ]]; then
  189. echo -e "${red}Failed to fetch x-ui version, it may be due to GitHub API restrictions, please try it later${plain}"
  190. exit 1
  191. fi
  192. echo -e "Got x-ui latest version: ${tag_version}, beginning the installation..."
  193. wget -N --no-check-certificate -O /usr/local/x-ui-linux-$(arch).tar.gz https://github.com/MHSanaei/3x-ui/releases/download/${tag_version}/x-ui-linux-$(arch).tar.gz
  194. if [[ $? -ne 0 ]]; then
  195. echo -e "${red}Downloading x-ui failed, please be sure that your server can access GitHub ${plain}"
  196. exit 1
  197. fi
  198. else
  199. tag_version=$1
  200. tag_version_numeric=${tag_version#v}
  201. min_version="2.3.5"
  202. if [[ "$(printf '%s\n' "$min_version" "$tag_version_numeric" | sort -V | head -n1)" != "$min_version" ]]; then
  203. echo -e "${red}Please use a newer version (at least v2.3.5). Exiting installation.${plain}"
  204. exit 1
  205. fi
  206. url="https://github.com/MHSanaei/3x-ui/releases/download/${tag_version}/x-ui-linux-$(arch).tar.gz"
  207. echo -e "Beginning to install x-ui $1"
  208. wget -N --no-check-certificate -O /usr/local/x-ui-linux-$(arch).tar.gz ${url}
  209. if [[ $? -ne 0 ]]; then
  210. echo -e "${red}Download x-ui $1 failed, please check if the version exists ${plain}"
  211. exit 1
  212. fi
  213. fi
  214. if [[ -e /usr/local/x-ui/ ]]; then
  215. systemctl stop x-ui
  216. rm /usr/local/x-ui/ -rf
  217. fi
  218. tar zxvf x-ui-linux-$(arch).tar.gz
  219. rm x-ui-linux-$(arch).tar.gz -f
  220. cd x-ui
  221. chmod +x x-ui
  222. # Check the system's architecture and rename the file accordingly
  223. if [[ $(arch) == "armv5" || $(arch) == "armv6" || $(arch) == "armv7" ]]; then
  224. mv bin/xray-linux-$(arch) bin/xray-linux-arm
  225. chmod +x bin/xray-linux-arm
  226. fi
  227. chmod +x x-ui bin/xray-linux-$(arch)
  228. cp -f x-ui.service /etc/systemd/system/
  229. wget --no-check-certificate -O /usr/bin/x-ui https://raw.githubusercontent.com/MHSanaei/3x-ui/main/x-ui.sh
  230. chmod +x /usr/local/x-ui/x-ui.sh
  231. chmod +x /usr/bin/x-ui
  232. config_after_install
  233. systemctl daemon-reload
  234. systemctl enable x-ui
  235. systemctl start x-ui
  236. echo -e "${green}x-ui ${tag_version}${plain} installation finished, it is running now..."
  237. echo -e ""
  238. echo -e "x-ui control menu usages: "
  239. echo -e "----------------------------------------------"
  240. echo -e "SUBCOMMANDS:"
  241. echo -e "x-ui - Admin Management Script"
  242. echo -e "x-ui start - Start"
  243. echo -e "x-ui stop - Stop"
  244. echo -e "x-ui restart - Restart"
  245. echo -e "x-ui status - Current Status"
  246. echo -e "x-ui settings - Current Settings"
  247. echo -e "x-ui enable - Enable Autostart on OS Startup"
  248. echo -e "x-ui disable - Disable Autostart on OS Startup"
  249. echo -e "x-ui log - Check logs"
  250. echo -e "x-ui banlog - Check Fail2ban ban logs"
  251. echo -e "x-ui update - Update"
  252. echo -e "x-ui legacy - legacy version"
  253. echo -e "x-ui install - Install"
  254. echo -e "x-ui uninstall - Uninstall"
  255. echo -e "----------------------------------------------"
  256. }
  257. echo -e "${green}Running...${plain}"
  258. install_base
  259. install_x-ui $1